/// @cond EO_CXX_EO_IMPL

inline bool elm::systray::register_() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_register());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::systray::id_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_id_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::systray::id_set(::efl::eina::optional< ::efl::eina::string_view > id_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_id_set(::efl::eolian::to_c(id_)));
}

inline Elm_Systray_Category elm::systray::category_get() const
{
   Elm_Systray_Category _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_category_get());
   return _tmp_ret;
}

inline void elm::systray::category_set(Elm_Systray_Category cat_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_category_set(cat_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::systray::icon_theme_path_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_icon_theme_path_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::systray::icon_theme_path_set(::efl::eina::optional< ::efl::eina::string_view > icon_theme_path_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_icon_theme_path_set(::efl::eolian::to_c(icon_theme_path_)));
}

inline const Eo * elm::systray::menu_get() const
{
   const Eo * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_menu_get());
   return _tmp_ret;
}

inline void elm::systray::menu_set(const Eo * menu_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_menu_set(menu_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::systray::att_icon_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_att_icon_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::systray::att_icon_name_set(::efl::eina::optional< ::efl::eina::string_view > att_icon_name_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_att_icon_name_set(::efl::eolian::to_c(att_icon_name_)));
}

inline Elm_Systray_Status elm::systray::status_get() const
{
   Elm_Systray_Status _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_status_get());
   return _tmp_ret;
}

inline void elm::systray::status_set(Elm_Systray_Status st_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_status_set(st_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::systray::icon_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_icon_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::systray::icon_name_set(::efl::eina::optional< ::efl::eina::string_view > icon_name_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_icon_name_set(::efl::eolian::to_c(icon_name_)));
}

inline ::efl::eina::optional< ::efl::eina::string_view > elm::systray::title_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_title_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void elm::systray::title_set(::efl::eina::optional< ::efl::eina::string_view > title_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_title_set(::efl::eolian::to_c(title_)));
}

inline bool eo_cxx::elm::systray::register_() const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_register());
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::systray::id_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_id_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::systray::id_set(::efl::eina::optional< ::efl::eina::string_view > id_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_id_set(::efl::eolian::to_c(id_)));
}

inline Elm_Systray_Category eo_cxx::elm::systray::category_get() const
{
   Elm_Systray_Category _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_category_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::systray::category_set(Elm_Systray_Category cat_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_category_set(cat_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::systray::icon_theme_path_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_icon_theme_path_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::systray::icon_theme_path_set(::efl::eina::optional< ::efl::eina::string_view > icon_theme_path_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_icon_theme_path_set(::efl::eolian::to_c(icon_theme_path_)));
}

inline const Eo * eo_cxx::elm::systray::menu_get() const
{
   const Eo * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_menu_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::systray::menu_set(const Eo * menu_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_menu_set(menu_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::systray::att_icon_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_att_icon_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::systray::att_icon_name_set(::efl::eina::optional< ::efl::eina::string_view > att_icon_name_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_att_icon_name_set(::efl::eolian::to_c(att_icon_name_)));
}

inline Elm_Systray_Status eo_cxx::elm::systray::status_get() const
{
   Elm_Systray_Status _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_status_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::systray::status_set(Elm_Systray_Status st_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_status_set(st_));
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::systray::icon_name_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_icon_name_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::systray::icon_name_set(::efl::eina::optional< ::efl::eina::string_view > icon_name_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_icon_name_set(::efl::eolian::to_c(icon_name_)));
}

inline ::efl::eina::optional< ::efl::eina::string_view > eo_cxx::elm::systray::title_get() const
{
   const char * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_systray_title_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
}

inline void eo_cxx::elm::systray::title_set(::efl::eina::optional< ::efl::eina::string_view > title_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_systray_title_set(::efl::eolian::to_c(title_)));
}

inline ::eo_cxx::elm::systray::operator ::elm::systray() const
{
   return *static_cast<::elm::systray const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::systray::operator ::elm::systray&()
{
   return *static_cast<::elm::systray*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::systray::operator ::elm::systray const&() const
{
   return *static_cast<::elm::systray const*>(static_cast<void const*>(this));
}

template <typename T>
bool elm_systray_register__wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->register_();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_systray_id_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->id_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_systray_id_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * id_)
{
   try
      {
         static_cast<T*>(self->this_)->id_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(id_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Systray_Category elm_systray_category_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->category_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Systray_Category _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_systray_category_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Systray_Category cat_)
{
   try
      {
         static_cast<T*>(self->this_)->category_set(cat_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_systray_icon_theme_path_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->icon_theme_path_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_systray_icon_theme_path_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * icon_theme_path_)
{
   try
      {
         static_cast<T*>(self->this_)->icon_theme_path_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(icon_theme_path_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
const Eo * elm_systray_menu_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->menu_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Eo * _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_systray_menu_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const Eo * menu_)
{
   try
      {
         static_cast<T*>(self->this_)->menu_set(menu_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_systray_att_icon_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->att_icon_name_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_systray_att_icon_name_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * att_icon_name_)
{
   try
      {
         static_cast<T*>(self->this_)->att_icon_name_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(att_icon_name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Systray_Status elm_systray_status_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->status_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Systray_Status _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_systray_status_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Systray_Status st_)
{
   try
      {
         static_cast<T*>(self->this_)->status_set(st_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_systray_icon_name_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->icon_name_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_systray_icon_name_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * icon_name_)
{
   try
      {
         static_cast<T*>(self->this_)->icon_name_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(icon_name_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::optional< ::efl::eina::string_view > elm_systray_title_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->title_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const char * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
void elm_systray_title_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char * title_)
{
   try
      {
         static_cast<T*>(self->this_)->title_set(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(title_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::systray >
{
   template <typename T>
   struct type
         : virtual operations< ::eo::base >::template type<T>
   {
      virtual bool register_()
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_register());
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > id_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_id_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void id_set(::efl::eina::optional< ::efl::eina::string_view > id_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_id_set(::efl::eolian::to_c(id_)));
      }

      virtual Elm_Systray_Category category_get()
      {
         Elm_Systray_Category _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_category_get());
            return _tmp_ret;
      }

      virtual void category_set(Elm_Systray_Category cat_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_category_set(cat_));
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > icon_theme_path_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_icon_theme_path_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void icon_theme_path_set(::efl::eina::optional< ::efl::eina::string_view > icon_theme_path_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_icon_theme_path_set(::efl::eolian::to_c(icon_theme_path_)));
      }

      virtual const Eo * menu_get()
      {
         const Eo * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_menu_get());
            return _tmp_ret;
      }

      virtual void menu_set(const Eo * menu_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_menu_set(menu_));
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > att_icon_name_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_att_icon_name_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void att_icon_name_set(::efl::eina::optional< ::efl::eina::string_view > att_icon_name_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_att_icon_name_set(::efl::eolian::to_c(att_icon_name_)));
      }

      virtual Elm_Systray_Status status_get()
      {
         Elm_Systray_Status _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_status_get());
            return _tmp_ret;
      }

      virtual void status_set(Elm_Systray_Status st_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_status_set(st_));
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > icon_name_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_icon_name_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void icon_name_set(::efl::eina::optional< ::efl::eina::string_view > icon_name_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_icon_name_set(::efl::eolian::to_c(icon_name_)));
      }

      virtual ::efl::eina::optional< ::efl::eina::string_view > title_get()
      {
         const char * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_systray_title_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::string_view >>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void title_set(::efl::eina::optional< ::efl::eina::string_view > title_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_systray_title_set(::efl::eolian::to_c(title_)));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::systray >
{
   static constexpr int value = 
#if defined(SYSTRAY_PROTECTED) && defined(SYSTRAY_BETA)
      17
#elif defined(SYSTRAY_PROTECTED)
      17
#elif defined(SYSTRAY_BETA)
      17
#else
      17
#endif
      + operation_description_class_size<::eo::base >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::systray>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_register__wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_register);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_id_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_id_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_id_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_id_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_category_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_category_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_category_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_category_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_icon_theme_path_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_icon_theme_path_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_icon_theme_path_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_icon_theme_path_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_menu_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_menu_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_menu_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_menu_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_att_icon_name_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_att_icon_name_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_att_icon_name_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_att_icon_name_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_status_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_status_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_status_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_status_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_icon_name_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_icon_name_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_icon_name_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_icon_name_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_title_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_title_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_systray_title_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_systray_title_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::eo::base>(), &ops[operation_description_class_size< ::elm::systray >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::systray>)
{
   return (ELM_SYSTRAY_CLASS);
}

} } }

/// @endcond

